# Signed

Signed is a gem for adding digital signature


## Installation

Add this line to your application's Gemfile:

```ruby
gem 'signed'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install signed

## usage

to create signature

```ruby
require 'signed'

data = 'hello world'
secret = 'secret string'
Signed.sign(data, secret)

```
to verify signature

```ruby
require 'signed'
data = 'hello world'
secret = 'secret string'
signature = 'a683633f77b24215387902b1685586b456513a06a3990c339143cd4528ce2d26:aW5maW5pdA=='
Signed.verify?(data, signature, secret)
```
you can also add timestamp to set expiration

```ruby
Signed.sign(data, secret, expiry: timestamp)
```

if you want to change hashing algorithm

```ruby
Signed.sign(data, secret, algo: 'MD5')
# to verify signature
Signed.verify?(data, signature, secret, algo: 'MD5')
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/haseebeqx/signed. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.


## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).

